version: '3.1'
services:
  db:
    image: postgres
    restart: always
    ports: 
      - 5432:5432
    environment:
      POSTGRES_PASSWORD: example
    volumes:
      - ./postgres-data:/var/lib/postgresql/data
  db-test:
    image: postgres
    restart: always
    ports: 
      - 5433:5432
    environment:
      POSTGRES_PASSWORD: example
  adminer:
    image: adminer
    restart: always
    ports:
      - 8080:8080
  rabbitmq:
    image: rabbitmq:3.8-management-alpine
    restart: always
    ports:
      - 15672:15672
      - 5672:5672
    environment: 
      RABBITMQ_DEFAULT_USER: "rabbitmq"
      RABBITMQ_DEFAULT_PASS: "rabbitmq"
  mongo:
    image: mongo
    restart: always
    ports:
      - 27017:27017
    environment:
      MONGO_INITDB_ROOT_USERNAME: root
      MONGO_INITDB_ROOT_PASSWORD: example
    volumes: 
      - ./mongo-volume:/data/db
  mongo-express:
    image: mongo-express
    restart: always
    ports:
      - 8081:8081
    environment:
      ME_CONFIG_MONGODB_ADMINUSERNAME: root
      ME_CONFIG_MONGODB_ADMINPASSWORD: example
  ms-users:
    restart: always
    build: ./ms-users
    volumes: 
      - ./ms-users:/app
    env_file: 
      - ./ms-users/.env
    command: python main.py run
    depends_on: 
      - db
      - rabbitmq
  ms-bet:
    build: ./ms-bet
    restart: always
    volumes:
      - ./ms-bet:/app
    env_file: 
      - ./ms-bet/.env
    command: python main.py run
    depends_on:
      - rabbitmq
      - mongo
  ms-euro-league:
    build: ./ms-euro-league
    restart: always
    volumes: 
      - ./ms-euro-league:/app
    env_file: 
      - ./ms-euro-league/.env
    command: python main.py run
    depends_on: 
      - api-football-data-mock
      - rabbitmq
      - mongo
  ms-friend-leagues:
    build: ./ms-friend-leagues
    restart: always
    volumes: 
      - ./ms-friend-leagues:/app
    env_file: 
      - ./ms-friend-leagues/.env
    command: python main.py run
    depends_on: 
      - rabbitmq
      - mongo
  api-football-data-mock:
    build: ./api-football-data-mock
    restart: always
    volumes:
      - ./api-football-data-mock/:/app
      - ./api-football-data-mock/node_modules
    ports:
      - 3050:3050
    env_file: 
      - ./api-football-data-mock/.env
    command: nodemon
  api:
    build: ./api-gateway
    restart: always
    volumes: 
      - ./api-gateway:/app
    command: python manage.py dev
    depends_on: 
      - db
      - api-football-data-mock
      - rabbitmq
      - db-test
      - ms-users
      - ms-bet
      - ms-euro-league
      - ms-friend-leagues
    ports: 
      - "5000:5000"
    env_file: 
      - ./api-gateway/.env